/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

@import '../../style/utils/animations';

:host {
  //
  // Variables
  //
  --border-radius: 50px;
  --border-bottom-width: 2px;
  --width: 42px;
  --height: 42px;
  
  cursor: pointer;
  display: inline-block;
  position: relative;
  vertical-align: top; 
}

:host(.nv-button-block) {
  display: block;
  width: 100%;
}

:host(.details-open) {
  z-index: 20;

  ::before {
    display: none !important;
  }

  .details-slot {
    @extend .transition-entrance;
    opacity: 1;
    transform: translateY(4px);
    transition-delay: 0ms, 0s;
    transition-property: opacity, transform;
    visibility: visible;
  }
}

.nv-button-native {

  //
  // Base Style
  //
  @extend .transition-entrance;
  background-color: var(--nv-theme-alt-2);
  border: 0;
  border-bottom-color: var(--nv-border-color);
  border-bottom-style: solid;
  border-bottom-width: var(--border-bottom-width);
  border-radius: var(--border-radius);
  color: var(--nv-type-primary);
  cursor: pointer;
  display: flex;
  font-family: 'FiraGO Medium Italic';
  font-size: 14px;
  height: 42px;
  outline: none !important;
  position: relative;
  text-decoration: none;
  transition-property: opacity, background-color, color;
  white-space: nowrap;
  width: 100%;

  &::before {
    @extend .transition-entrance;
    background-color: var(--nv-theme-primary);
    border-radius: var(--border-radius);
    content: '';
    height: 100%;
    left: 0;
    opacity: 0;
    pointer-events: none;
    position: absolute;
    top: 0;
    transition-property: opacity;
    width: 100%;
    z-index: 0;
  }

  &:hover::before {
    @extend .transition-exit;
    opacity: 0.1;
  }

  &.nv-button-text {
    background-color: transparent !important;
    border-color: transparent !important;
  }

  // 
  // Primary
  // 

  &.nv-button-primary {
    background-color: var(--nv-theme-primary);
    border-bottom-color: var(--nv-theme-primary-dark);
    color: #{$type-primary-light};
    
    
    &::before {
      background-color: var(--nv-theme-primary-dark-alt);
    }
    
    &:hover::before {
      @extend .transition-exit;
      opacity: 1;
    }
    
    &.nv-button-disabled {
      background-color: var(--nv-theme-primary) !important;
      color: #{$type-primary-light} !important;
    }
  }

  // ----------------------------------------
  // Disabled style
  // ----------------------------------------
  
  &.disabled,
  &:disabled {
    background-color: var(--nv-theme-disabled);
    border-bottom-color: transparent;
    cursor: not-allowed;
  }

  > div {
    align-items: center;
    display: flex;
    height: 100%;
    justify-content: center;
    position: relative;
    z-index: 3;
  }

  // Fix height from buttons
  .badge {
    margin-bottom: -5px;
    margin-top: -5px;
  }

  // 
  // Circle Style
  //

  &.nv-button-circle {
    border-radius: 100% !important;
    height: var(--height);
    overflow: hidden;
    padding: 0;
    width: var(--width);

    > div {
      align-items: center;
      display: flex;
      height: 100%;
      justify-content: center;
      width: 100%;
    }

    &.nv-button-large {
      height: 90px;
      width: 90px;
    }

    .nv-button-slot-start,
    .nv-button-slot-end {
      display: none;
    }

    .nv-button-slot-content {
      padding: 0;
    }
  }

  //
  // Global size styles
  //

  // Small style
  &.nv-button-small {
    font-size: $font-size-sm;
    height: unset;
    padding: $space-sm;

    &.nv-button-circle {
      height: 32px;
      width: 32px;
    }
  }

  // Medium style
  &.nv-button-medium {
    font-size: $font-size-md;
    height: unset;
    padding: $space-md;
  }

  // Large style
  &.nv-button-large {
    font-size: $font-size-lg;
    height: unset;
    padding: $space-lg;
  }

  // Extra large style
  &.nv-button-big {
    font-size: $font-size-big;
    height: unset;
    padding: $space-big;
  }

  // 
  // Disabled
  // 

  &.nv-button-disabled {
    opacity: 0.6;
  }

  //
  // Content
  //

  .nv-button-slot-content {
    flex: 1;
    padding: 0 $space-default;
  }

  //
  // Slots
  //
 
  &.nv-button-start-slot .nv-button-slot-start {
    padding-left: $space-sm;
  }

  &.nv-button-start-slot .nv-button-slot-end {
    padding-right: $space-sm;
  }
  
  // Fix padding of button content
  &.nv-button-start-slot .nv-button-slot-content {
    padding-left: $space-sm;
  }

  &.nv-button-end-slot .nv-button-slot-content {
    padding-right: $space-sm;
  }
}

/*
* Removed pointer-events to prevent other elements like nv-icon from preventing button clicks when used in
* dropdown mode together with circle
*/

.nv-button-slot-content,
.nv-button-end-slot,
.nv-button-start-slot {
  pointer-events: none;
}


//
// Details Slot
//

.details-slot {
  @extend .transition-exit;
  background-color: var(--nv-theme-alt-2);
  border-color: var(--nv-border-color);
  border-bottom-color: var(--nv-border-color);
  border-radius: 8px;
  border-style: solid;
  border-bottom-style: solid;
  border-width: 0 0 2px;
  border-bottom-width: 2px;
  min-width: 100%;
  opacity: 0;
  overflow: hidden;
  position: absolute;
  right: 0;
  top: 100%;
  transform: translateY(-10%);
  transition-delay: 0ms, 100ms;
  transition-property: opacity, transform;
  visibility: hidden;
  z-index: 500;

  &:empty {
    display: none;
  }

  ::slotted(nv-button) {
    border-bottom-color: var(--nv-border-color);
    border-bottom-style: solid;
    border-bottom-width: 1px;
    display: block;
  }

  ::slotted(nv-button:last-child) {
    border-bottom-width: 0;
  }

  ::slotted(.nv-button) {
    width: 100%;
  }

  &.custom-drop-down {
    background-color: transparent;
    border-color: transparent;
    border-bottom-color: transparent;
    border-style: none;
    border-bottom-style: none;
    border-width: 0;
    border-bottom-width: 0;
    overflow: unset;
  }
}

.nv-button-details {
  border-radius: 0;
  white-space: nowrap;
  width: 100%;

  &.nv-button-native {
    border-bottom-width: 0;
    border-radius: 0;

    &:last-child {
      border-bottom-width: 0;
    }

    &::before {
      border-radius: 0 !important;
    }
  }
}

.nv-button-text-primary {
  color: var(--nv-theme-primary);
}

.nv-button-text-danger {
  color: var(--nv-theme-danger);
}
